import java.applet.*;
import java.awt.*;
import java.awt.image.*;

class RedactFilter extends RGBImageFilter
{
	int startX, startY, endX, endY;

	// the constructor is passed the coordinates of the are
	// to redact and stores these values
	public RedactFilter(int x, int y, int width, int height) 
	{
		startX = x;
		startY = y;
		endX   = startX + width;
		endY   = startY + height;
	}

	public int filterRGB(int x, int y, int rgb)
	{
		// if the (x,y) position is in the redacted area
		// return red, otherwise return the same color that
		// was passed in
		if (x >= startX && x <= endX && y >= startY && y <= endY)
			return 0xff0000ff;
		else
			return rgb;
	}
}


public class EX14H extends Applet
{
	private Image myImage;
	private Image redactedImage;

	public void init()
    {
        resize(570, 470);

		// get the original image
		myImage = getImage(getDocumentBase(), "savannah.jpg");

		// create a filter and specify the range to be redacted
		ImageFilter filter = new RedactFilter(220, 80, 80, 15);

		// create a new image source based on the original
		// image and the new filter
		FilteredImageSource imageSource = new FilteredImageSource(
				myImage.getSource(), filter);

		// create the redacted image from the image source
		redactedImage = createImage(imageSource);
    }

    public void paint(Graphics g)
    {
		// paint the redacted image
		g.drawImage(redactedImage, 0, 0, this);
    }
}

